

  program

  Include('BUILTINS.CLW'),ONCE
  Include('KEYCODES.CLW'),ONCE
  Include('CLIB.EQ8'),ONCE

DWORD                                       EQUATE(ULONG)

  map
    module('windows api')
      lStrCpy(LONG,LONG),LONG,PASCAL,NAME('lstrcpyA')
      SetErrorMode(Ulong),Ulong,Pascal
      LoadLibrary(ULONG),Ulong,PASCAL,Name('LoadLibraryA')
      GetLastError(),DWORD,PASCAL
      GetProcAddress(Long,Long),Long,Pascal
    end
    Module('asmhelp')
     DebugBreak(),name('_DbgBreak')
     ThrowGPF(),Name('_ThrowGPF')

     ! param 1 is the address of the proc to call
     !       2 = 0
     !       3 = 0
     !       4 = 0
     !       5 = param 1 to proc you're calling
     !       6 = param 2 to proc you're calling
     !         etc
     CallPtr_P0(long,long,long,long),long,name('_CallPtr')  ! 0 params
     CallPtr_P1(long,long,long,long,long),long,Name('_CallPtr') ! 1 param
     CallPtr_P2(long,long,long,long,long,long),long,Name('_CallPtr')  ! 2
     CallPtr_P3(long,long,long,long,long,long,long),long,Name('_CallPtr') ! 3
     CallPtr_P4(long,long,long,long,long,long,long,long),long,Name('_CallPtr')  ! 4
     CallPtr_P5(long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 5
     CallPtr_P6(long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr')  ! 6
     CallPtr_P7(long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 7
     CallPtr_P8(long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr')  ! 8
     CallPtr_P9(long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 9
     CallPtr_P10(long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 10

     CallPtr_p11(long,long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 11
     CallPtr_p12(long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 12
     CallPtr_p13(long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 13
     CallPtr_p14(long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 14
     CallPtr_p15(long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long,long),long,Name('_CallPtr') ! 15

     FixStack(long,long,long,long),long,name('_FIXSTACK')
    End
    vddemo:Main
    VDM_Process_CB(long,long,long),bool,pascal
    VDM_Task_CB(long,short,short,ulong,ulong,ulong),bool,pascal
  end

VDMProcessQ         Queue
PID                   Long
Attr                  Long
                    End

VDMTaskQ            Queue
ThreadID              ULong
ModuleHdl             ULong
TaskHdl               ULong
ModuleName            CString(300)
FileName              CString(300)
                    End

DLL_Name            CString(50)
DLL_Handle          ULOng

SEM_FAILCRITICALERRORS              EQUATE(00001H)
SEM_NOGPFAULTERRORBOX               EQUATE(00002H)
SEM_NOALIGNMENTFAULTEXCEPT          EQUATE(00004H)
SEM_NOOPENFILEERRORBOX              EQUATE(08000H)


  code
  ! Obviously this doesn't run on a 64bit OS (doesn't support 16bit apps)
  !   or 16bit OS (this app is compiled for 32bit, a 16bit app wouldn't
  !   call the VDM APIs in the first place)
  !
  ! It's left as an exercise for the reader to determine if this is
  ! the correct OS or not :)
  vddemo:main()

! **************************************************************************************************************************
VDM_Process_CB Function(dwprocessID,dwAttributes,lpUserDefined)
! https://learn.microsoft.com/en-us/previous-versions/bb963829(v=vs.85)
! **************************************************************************************************************************
  code
  VDMProcessQ:PID = dwprocessID
  VDMProcessQ:Attr = dwAttributes
  Add(VDMProcessQ)
  Return(False)

! **************************************************************************************************************************
VDM_Task_CB Function(dwThreadID,hMod16,hTask16,pszModName,pszFilename,lpUserDefined)
! https://learn.microsoft.com/en-us/windows/win32/api/vdmdbg/nf-vdmdbg-vdmenumtaskwowex
! https://learn.microsoft.com/en-us/previous-versions/bb963828(v=vs.85)
! **************************************************************************************************************************

  Code
  VDMTaskQ:ThreadID = dwThreadID
  VDMTaskQ:ModuleHdl = hMod16
  VDMTaskQ:TaskHdl = hTask16
  a# = lstrcpy(Address(VDMTaskQ:ModuleName),pszModName)
  b# = lstrcpy(Address(VDMTaskQ:FileName),pszFilename)
  Add(VDMTaskQ)
  Return(False)



! **************************************************************************************************************************
vddemo:main procedure
! **************************************************************************************************************************

Window WINDOW('VdmDBG API Demo'),AT(,,505,242),FONT('MS Sans Serif',8,,FONT:regular),GRAY
       BUTTON('1. Load VDMDBG.DLL'),AT(8,7,136,14),USE(?LoadDLL)
       BUTTON('2. Enumerate VDM process'),AT(8,96,136,14),USE(?EnumProcess),Disable
       LIST,AT(9,30,133,62),USE(?ProcessList),VSCROLL,FORMAT('45L(2)|M~PID~@n06@20L(2)|M~Atrtibutes~@n06@'), |
           FROM(VDMProcessQ)
       LIST,AT(167,30,329,62),USE(?TaskList),HVSCROLL,FORMAT('44L(2)|M~Thread ID~35L(2)|M~Module~37L(2)|M~Task~69L(2)|M~Module Name~@s50@20L(2' &|
           ')|M~File Name~@s50@'),FROM(VDMTaskQ)
       BUTTON('3. Enumerate 16-bit processes (AKA tasks) for selected VDM'),AT(167,96,327,14),USE(?EnumTasks),Disable
       BUTTON('&OK'),AT(460,223,35,14),USE(?OkButton),LEFT,DEFAULT
     END


  code
  DLL_Name = 'VDMDBG.dll'

  open(window)
  accept
    case event()
    of event:Accepted
      case Accepted()
      of ?OKButton
        Break
      Of ?LoadDLL
        Do vddemo:LoadDLL

      of ?EnumProcess
        Do vddemo:Main_EnumProcess
      of ?EnumTasks
        Do vddemo:Main_EnumTasks
      of ?ProcessList
        c# = Choice(?ProcessList)
        Get(VDMProcessQ, c#)
      end
    end
  end
  close(window)

! -------------------------------------------------------------------------------------------------
vddemo:LoadDLL Routine
  Data
R:ErrorMode           Long
  Code
  ! no errors to the user if the DLL fails to load
  R:ErrorMode = SetErrorMode(SEM_FAILCRITICALERRORS)
  DLL_Handle = LoadLibrary( Address(DLL_Name) )

  ! Reset the error back to what it was originally
  x# = SetErrorMode(R:ErrorMode)

  Message('DLL handle = ' & DLL_Handle,'Info')
  If DLL_Handle <> 0
    Enable(?EnumProcess)
    Enable(?EnumTasks)
  End

! -------------------------------------------------------------------------------------------------
! Enumerate virtual DOS machines running 16-bit Windows tasks.
vddemo:Main_EnumProcess routine
  Data
R:ProcedureName       CString(50)
R:ProcedureAddress    ULOng
  Code
  Clear(VDMProcessQ)
  Free(VDMProcessQ)

  R:ProcedureName = 'VDMEnumProcessWOW'
  R:ProcedureAddress = GetProcAddress( DLL_Handle , Address(R:ProcedureName) )
  If R:ProcedureAddress = 0
    Message('Unable to find ' & R:ProcedureName,'Error!')
  Else
    Message('Procedure address = ' & R:ProcedureAddress,'Info!')
    ! 1st param is address of the API to call
    !
    ! Next 3 are all 0 (to fill the registers in the JPI calling convention,
    !   and force everything else to go on the stack)
    !
    ! 2 after that are the 2 params to the API call, in reverse order
    !   because it's the Pascal calling convention
    process_count# = CallPtr_P2(R:ProcedureAddress,0,0,0,42,Address(VDM_Process_CB))
  End

! -------------------------------------------------------------------------------------------------
! For the selected VDM (from step 1) enumerate all 16bit processes (aka Tasks) within that VDM
vddemo:Main_EnumTasks routine
  Data
R:ProcedureName       CString(50)
R:ProcedureAddress    ULOng
  Code
  Clear(VDMTaskQ)
  Free(VDMTaskQ)

  R:ProcedureName = 'VDMEnumTaskWOWEx'
  R:ProcedureAddress = GetProcAddress( DLL_Handle , Address(R:ProcedureName) )
  If R:ProcedureAddress = 0
    Message('Unable to find ' & R:ProcedureName,'Error!')
  Else
    Message('Procedure address = ' & R:ProcedureAddress,'Info!')
    ! Same as above except there's 3 params to the API clal
    task_count# = CallPtr_P3(R:ProcedureAddress,0,0,0,42,Address(VDM_Task_CB),VDMProcessQ:PID)
  End

